// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'SMIZipFile.pas' rev: 3.00

#ifndef SMIZipFileHPP
#define SMIZipFileHPP
#include <SysUtils.hpp>
#include <Windows.hpp>
#include <Classes.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Smizipfile
{
//-- type declarations -------------------------------------------------------
#pragma pack(push, 1)
struct TCommonFileHeader
{
	Word VersionNeededToExtract;
	Word GeneralPurposeBitFlag;
	Word CompressionMethod;
	int LastModFileTimeDate;
	int Crc32;
	int CompressedSize;
	int UncompressedSize;
	Word FilenameLength;
	Word ExtraFieldLength;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TFileHeader
{
	int CentralFileHeaderSignature;
	Word VersionMadeBy;
	TCommonFileHeader CommonFileHeader;
	Word FileCommentLength;
	Word DiskNumberStart;
	Word InternalFileAttributes;
	int ExternalFileAttributes;
	int RelativeOffsetOfLocalHeader;
	System::AnsiString FileName;
	System::AnsiString ExtraField;
	System::AnsiString FileComment;
} ;
#pragma pack(pop)

#pragma pack(push, 1)
struct TEndOfCentralDir
{
	int EndOfCentralDirSignature;
	Word NumberOfThisDisk;
	Word NumberOfTheDiskWithTheStart;
	Word TotalNumberOfEntriesOnThisDisk;
	Word TotalNumberOfEntries;
	int SizeOfTheCentralDirectory;
	int OffsetOfStartOfCentralDirectory;
	Word ZipfileCommentLength;
} ;
#pragma pack(pop)

class DELPHICLASS TLocalFile;
class PASCALIMPLEMENTATION TLocalFile : public Classes::TCollectionItem 
{
	typedef Classes::TCollectionItem inherited;
	
private:
	int FLocalFileHeaderSignature;
	TCommonFileHeader FCommonFileHeader;
	System::AnsiString FFileName;
	System::AnsiString FExtraField;
	System::AnsiString FCompressedData;
	int FCentralFileHeaderSignature;
	Word FCentralVersionMadeBy;
	TCommonFileHeader FCentralCommonFileHeader;
	Word FCentralFileCommentLength;
	Word FCentralDiskNumberStart;
	Word FCentralInternalFileAttributes;
	int FCentralExternalFileAttributes;
	int FCentralRelativeOffsetOfLocalHeader;
	System::AnsiString FCentralFileName;
	System::AnsiString FCentralExtraField;
	System::AnsiString FCentralFileComment;
	
protected:
	bool FHeaderRead;
	
public:
	virtual void __fastcall Assign(Classes::TPersistent* Source);
	void __fastcall LoadFileFromStream(Classes::TStream* AStream);
	void __fastcall LoadCentralDirectoryFromStream(Classes::TStream* AStream);
	
__published:
	__property int LocalFileHeaderSignature = {read=FLocalFileHeaderSignature, write=FLocalFileHeaderSignature
		, nodefault};
	__property TCommonFileHeader CommonFileHeader = {read=FCommonFileHeader, write=FCommonFileHeader};
	__property System::AnsiString FileName = {read=FFileName, write=FFileName};
	__property System::AnsiString ExtraField = {read=FExtraField, write=FExtraField};
	__property System::AnsiString CompressedData = {read=FCompressedData, write=FCompressedData};
	__property int CentralFileHeaderSignature = {read=FCentralFileHeaderSignature, write=FCentralFileHeaderSignature
		, nodefault};
	__property Word CentralVersionMadeBy = {read=FCentralVersionMadeBy, write=FCentralVersionMadeBy, nodefault
		};
	__property TCommonFileHeader CentralCommonFileHeader = {read=FCentralCommonFileHeader, write=FCentralCommonFileHeader
		};
	__property Word CentralFileCommentLength = {read=FCentralFileCommentLength, write=FCentralFileCommentLength
		, nodefault};
	__property Word CentralDiskNumberStart = {read=FCentralDiskNumberStart, write=FCentralDiskNumberStart
		, nodefault};
	__property Word CentralInternalFileAttributes = {read=FCentralInternalFileAttributes, write=FCentralInternalFileAttributes
		, nodefault};
	__property int CentralExternalFileAttributes = {read=FCentralExternalFileAttributes, write=FCentralExternalFileAttributes
		, nodefault};
	__property int CentralRelativeOffsetOfLocalHeader = {read=FCentralRelativeOffsetOfLocalHeader, write=
		FCentralRelativeOffsetOfLocalHeader, nodefault};
	__property System::AnsiString CentralFileName = {read=FCentralFileName, write=FCentralFileName};
	__property System::AnsiString CentralExtraField = {read=FCentralExtraField, write=FCentralExtraField
		};
	__property System::AnsiString CentralFileComment = {read=FCentralFileComment, write=FCentralFileComment
		};
public:
	/* TCollectionItem.Create */ __fastcall virtual TLocalFile(Classes::TCollection* Collection) : Classes::
		TCollectionItem(Collection) { }
	/* TCollectionItem.Destroy */ __fastcall virtual ~TLocalFile(void) { }
	
};

class DELPHICLASS TLocalFiles;
class PASCALIMPLEMENTATION TLocalFiles : public Classes::TCollection 
{
	typedef Classes::TCollection inherited;
	
private:
	Classes::TComponent* FControl;
	TLocalFile* __fastcall GetLocalFile(int Index);
	void __fastcall SetLocalFile(int Index, TLocalFile* Value);
	
protected:
	DYNAMIC Classes::TPersistent* __fastcall GetOwner(void);
	
public:
	__fastcall TLocalFiles(Classes::TComponent* ACntrl);
	HIDESBASE TLocalFile* __fastcall Add(void);
	__property Classes::TComponent* OwnerControl = {read=FControl};
	__property TLocalFile* Items[int Index] = {read=GetLocalFile, write=SetLocalFile/*, default*/};
public:
		
	/* TCollection.Destroy */ __fastcall virtual ~TLocalFiles(void) { }
	
};

class DELPHICLASS TZipArchive;
class PASCALIMPLEMENTATION TZipArchive : public Classes::TComponent 
{
	typedef Classes::TComponent inherited;
	
private:
	TLocalFiles* Files;
	TEndOfCentralDir EndOfCentralDirectory;
	System::AnsiString ZipFileComment;
	System::AnsiString __fastcall GetUncompressed(int i);
	int __fastcall GetCount(void);
	
public:
	__fastcall virtual TZipArchive(Classes::TComponent* AOwner);
	__fastcall virtual ~TZipArchive(void);
	int __fastcall GetIndexByFileName(const System::AnsiString AFileName);
	System::AnsiString __fastcall DecompressFileName(const System::AnsiString AFileName);
	void __fastcall LoadFromFile(const System::AnsiString FileName);
	void __fastcall LoadFromStream(const Classes::TStream* ZipFileStream);
	void __fastcall GetFileNames(Classes::TStrings* lstFiles);
	__property int Count = {read=GetCount, nodefault};
	__property System::AnsiString Uncompressed[int i] = {read=GetUncompressed};
};

class DELPHICLASS EZipFileCRCError;
class PASCALIMPLEMENTATION EZipFileCRCError : public Sysutils::Exception 
{
	typedef Sysutils::Exception inherited;
	
public:
	/* Exception.Create */ __fastcall EZipFileCRCError(const System::AnsiString Msg) : Sysutils::Exception(
		Msg) { }
	/* Exception.CreateFmt */ __fastcall EZipFileCRCError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size) : Sysutils::Exception(Msg, Args, Args_Size) { }
	/* Exception.CreateRes */ __fastcall EZipFileCRCError(int Ident, Extended Dummy) : Sysutils::Exception(
		Ident, Dummy) { }
	/* Exception.CreateResFmt */ __fastcall EZipFileCRCError(int Ident, const System::TVarRec * Args, const 
		int Args_Size) : Sysutils::Exception(Ident, Args, Args_Size) { }
	/* Exception.CreateHelp */ __fastcall EZipFileCRCError(const System::AnsiString Msg, int AHelpContext
		) : Sysutils::Exception(Msg, AHelpContext) { }
	/* Exception.CreateFmtHelp */ __fastcall EZipFileCRCError(const System::AnsiString Msg, const System::TVarRec 
		* Args, const int Args_Size, int AHelpContext) : Sysutils::Exception(Msg, Args, Args_Size, AHelpContext
		) { }
	/* Exception.CreateResHelp */ __fastcall EZipFileCRCError(int Ident, int AHelpContext) : Sysutils::
		Exception(Ident, AHelpContext) { }
	/* Exception.CreateResFmtHelp */ __fastcall EZipFileCRCError(int Ident, const System::TVarRec * Args
		, const int Args_Size, int AHelpContext) : Sysutils::Exception(Ident, Args, Args_Size, AHelpContext
		) { }
	
public:
	/* TObject.Destroy */ __fastcall virtual ~EZipFileCRCError(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Smizipfile */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Smizipfile;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// SMIZipFile
