unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SMIBase, SMI2XML, StdCtrls, Grids, DBGrids, Db, DBTables;

type
  TForm1 = class(TForm)
    DataSource1: TDataSource;
    Table1: TTable;
    DBGrid1: TDBGrid;
    Button1: TButton;
    SMImportFromXML1: TSMImportFromXML;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
procedure TForm1.FormCreate(Sender: TObject);
begin
  {open dbf-file}
  Table1.DatabaseName := ExtractFilePath(Application.ExeName);
  Table1.TableType := ttDBase;
  Table1.TableName := 'orders';
  Table1.Open
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  {load data to dbf-file}
  SMImportFromXML1.DataSet := Table1;

  {load from xml-file}
  SMImportFromXML1.SourceFileName := ExtractFilePath(Application.ExeName) + 'orders.xml';

  {define a correspondence between fields in table and Tags in XML
  For our XML we have same names}
  SMImportFromXML1.Mappings.Clear;
  SMImportFromXML1.Mappings.Add('ID=OrderID');
  SMImportFromXML1.Mappings.Add('SHIPNAME=ShipToName');
  SMImportFromXML1.Mappings.Add('SHIPADDR1=ShipToAddress1');
  SMImportFromXML1.Mappings.Add('SHIPADDR2=ShipToAddress2');
  SMImportFromXML1.Mappings.Add('SHIPADDR3=ShipToAddress3');
  SMImportFromXML1.Mappings.Add('SHIPADDRX=ShipToAddressX');
  SMImportFromXML1.Mappings.Add('SHIPSTATE=ShipToState');
  SMImportFromXML1.Mappings.Add('SHIPZIP=ShipToZip');
  SMImportFromXML1.Mappings.Add('WEIGHT=OrderWeight');
  SMImportFromXML1.Mappings.Add('WAREHOUSE=ShipWarehouse');
  SMImportFromXML1.Mappings.Add('SHIPTIME=ShipTime');


  {define the main TAG where we have sub-nodes with data for loading}
  SMImportFromXML1.XMLTags.CaseSensitive := True;
  SMImportFromXML1.XMLTags.RecordsTag := 'ShippingAddresses';
  SMImportFromXML1.XMLTags.RecordTag := 'AddressRecord';

  {define custom formats}
  SMImportFromXML1.DataFormats.DateSeparator := '-';
  SMImportFromXML1.DataFormats.CustomDateTimeFormat := 'yyyy-mm-dd';
  SMImportFromXML1.DataFormats.DecimalSeparator := '.';

  {activate an import}
  SMImportFromXML1.Mode := imCopy;
  SMImportFromXML1.Execute
end;

end.
